Different Layouts in EJ2 JavaScript Splitter

21 Aug 202620 minutes to read

The Splitter control supports creating layouts with multiple and nested panes.

Code editor style layout

Step 1:
Create the element with two child elements to render the outer splitter.

 <div id="VerticalSplitter">
        <div id="HorizontalSplitter">
        </div>
        <div>
        <div class="content">
                <h3 class="h3">Preview of sample</h3>
                <div class="splitter-image">
                    <img class="img1" src="https://ej2.syncfusion.com/demos/src/listview/images/albert.png" style="width: 20%;margin: 0 auto;">
                </div>
            </div>
        </div>
</div>

  let VerticalSplitObj: Splitter = new Splitter({
        height: '400px',
        paneSettings: [
            { size: '53%', min: '30%' },
        ],
        orientation: 'Vertical'
    });
  VerticalSplitObj.appendTo('#VerticalSplitter');

Step 2 :

Render the first pane of the vertical splitter as a horizontal splitter.

 <div id="VerticalSplitter">
        <div id="HorizontalSplitter">
            <div>
                <div class="content">
                    <h3 class="h3">HTML</h3>
                    <div class="code-preview">
                        &lt;<span>!DOCTYPE html></span>
                        <div>&lt;<span>html></span></div>
                        <div>&lt;<span>body></span></div>
                        &lt;<span>div</span> id="custom-image">
                        <div style="margin-left: 5px">&lt;<span>img</span>src="src/albert.png"></div>
                        <div>&lt;<span>div</span>&gt;</div>
                        <div>&lt;<span>/body></span></div>
                        <div>&lt;<span>/html></span></div>
                    </div>
                </div>
            </div>
            <div>
                <div class="content">
                    <h3 class="h3">CSS</h3>
                    <div class="code-preview">
                        <span>img {</span>
                            <div id="code-text">margin:<span>0 auto;</span></div>
                            <div id="code-text">display:<span>flex;</span></div>
                            <div id="code-text">height:<span>70px;</span></div>
                        <span>   }</span>
                    </div>
                </div>
            </div>
            <div>
                <div class="content">
                    <h3 class="h3">JavaScript</h3>
                    <div class="code-preview">
                        <span>var</span> image = document.getElementById("custom-image");
                        <div>image.addEventListener("click", function() {</div>
                            <div style="padding-left: 20px;">// Code block for click action</div>
                        <span> }</span>
                    </div>
                </div>
            </div>
        </div>
        <div class="content">
            <h3 class="h3">Preview of sample</h3>
            <div class="splitter-image">
                <img class="img1" src="https://ej2.syncfusion.com/demos/src/listview/images/albert.png" style="width: 20%;margin: 0 auto;">
            </div>
        </div>
    </div>

    let HorizontalSplitObj: Splitter = new Splitter({
        height: '220px',
        paneSettings: [
            { size: '29%', min: '23%' },
            { size: '20%', min: '15%' },
            { size: '35%', min: '35%' }
        ],
        width: '100%'
    });
    HorizontalSplitObj.appendTo('#HorizontalSplitter');
    .code-preview {
        margin-top: 15px;
        font-size: 12px;
    }
    .content {
        padding: 12px;
    }
    .splitter-image {
        margin: 0 auto;
        display: flex;
        height: 115px;
        margin-top: 10px;
    }

After completing the configurations, the output appears as shown in thedemo:

Outlook style layout

Step 1:

Create the element with three panes and place the elements within the panes to render treeview, listview and RTE.


 <div id="splitter1">
        <div>
            <div class="content">
                <div id="tree"></div>
            </div>
        </div>
        <div>
            <div class="content">
                <div id="groupedList" tabindex="1"></div>
            </div>
        </div>
        <div>
            <div class="content">
                <div style="width: 100%; padding: 15px;">
                    <table>
                        <tr>
                            <td><button class="e-btn e-flat e-outline">To...</button></td>
                            <td><input id="firstname" /></td>
                        </tr>
                        <tr>
                            <td><button class="e-btn e-flat e-outline">Cc...</button></td>
                            <td><input id="lastname" /></td>
                        </tr>
                        <tr>
                            <td><div id="subject-text">Subject</div></td>
                            <td><input id="subject" /></td>
                        </tr>
                    </table>
                </div>
                <div class="forum">
                    <div id="createpostholder">
                        <div id="defaultRTE"> </div>
                        <div id="buttonSection">
                            <button class="e-btn e-primary" id="send">Send</button>
                            <button class="e-btn" id="discard">Discard</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

Step 2 :

Place the template script to render the treeview.

<script id="treeTemplate" type="text/x-template">
    <div>
        <div class="treeviewdiv">
            <div style="float:left">
                <span class="treeName">${name}</span>
            </div>
            ${if(count)}
                <div style="margin-right: 5px; float:right">
                    <span class="treeCount e-badge e-badge-primary">${count}</span>
                </div>
            ${/if}
        </div>
    </div>
</script>

Step 3 :

Render the listed controls one by one.

    let splitObj1: Splitter = new Splitter({
        height: '493px',
        paneSettings: [
            { size: '28%', min: '27%' },
            { size: '33%', min: '23%' },
            { size: '37%', min: '30%' }
        ],
        width: '100%'
    });
    splitObj1.appendTo('#splitter1');
    let inputobj1: TextBox = new TextBox({
    });
    inputobj1.appendTo('#firstname');
    let inputobj2: TextBox = new TextBox({
    });
    inputobj2.appendTo('#lastname');
    let inputobj3: TextBox = new TextBox({
    });
    inputobj3.appendTo('#subject');
    // Data source for TreeView component
    let mailBox: { [key: string]: Object }[] = [
        { id: 1, name: 'Favorites', hasChild: true},
        { id: 2, pid: 1, name: 'Sales Reports', count: '4' },
        { id: 3, pid: 1, name: 'Sent Items'},
        { id: 4, pid: 1, name: 'Marketing Reports ', count: '6'},
        { id: 5, name: 'Andrew Fuller', hasChild: true, expanded: true },
        { id: 6, pid: 5, name: 'Inbox',  selected: true , count: '20'},
        { id: 7, pid: 5,  name: 'Drafts', count: '5'},
        { id: 15, pid: 5, name: 'Archive'},
        { id: 8, pid: 5,  name: 'Deleted Items'},
        { id: 9, pid: 5, name: 'Sent Items'},
        { id: 10, pid: 5, name: 'Sales Reports' , count: '4'},
        { id: 11, pid: 5, name: 'Marketing Reports', count: '6' },
        { id: 12, pid: 5, name: 'Outbox'},
        { id: 13, pid: 5, name: 'Junk Email'},
        { id: 14, pid: 5, name: 'RSS Feed'},
        { id: 15, pid: 5, name: 'Trash' }
    ];
    // Render the TreeView using template option
    let treeObj: TreeView = new TreeView({
        fields: { dataSource: mailBox, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' },
        nodeTemplate: '#treeTemplate',
    });
    treeObj.appendTo('#tree');
    // tslint:disable:max-line-length
    //Define an array of JSON data
    let dataSource: any = [
        { Name: 'Selma Tally', content: '<div><div class="status">Apology marketing email</div><div id="list-message">Hello Ananya Singleton</div>', id: '1', order: 0 },
        { Name: 'Illa Russo', content: '<div><div class="status">Annual conference</div><div id="list-message">Hi jeani Moresa</div></div>', id: '4', order: 0 },
        { Name: 'Camden Macmellon', content: '<div><div class="status">Reference request- Camden hester</div><div id="list-message">Hello Kerry Best,</div></div>', order: 0 },
        { Name: 'Garth Owen', content: '<div><div class="status">Application for job Title</div><div id="list-message">Hello Illa Russo</div></div>', id: '2', order: 0 },
        { Name: 'Ursula Patterson', content: '<div><div class="status">Programmaer Position Applicant</div><div id="list-message">Hello Kerry best,</div></div>', id: '2', order: 0 }
    ];

    // Initialize ListView component
    let listObj: ListView = new ListView({
        //Set defined data to dataSource property
        dataSource: dataSource,
        cssClass: 'e-list-template',
        //Map the appropriate columns to fields property
        fields: { text: 'Name', groupBy: 'order' },
        //Set customized group-header template
        groupTemplate: '<div class="e-list-wrapper"><span class="e-list-item-content"></span></div>',
        //Set customized list template
        template: '<div class="settings e-list-wrapper e-list-multi-line e-list-avatar">' +
        '<span class="e-list-item-header">${Name}</span>' +
        '<span class="e-list-content">${content}</span>' +
        '</div>'
    });

    //Render initialized ListView component
    listObj.appendTo('#groupedList');

    let button1: Button = new Button({ isPrimary: true });
    button1.appendTo('#rteSubmit');

    let button2: Button = new Button();
    button2.appendTo('#rteCancel');

    let defaultRTE: RichTextEditor = new RichTextEditor({ height: '262px'});
    defaultRTE.appendTo('#defaultRTE');
  <style>
    #target {
        margin: 20px auto;
        max-width: 820px;
    }
    .e-treeview .e-list-text {
        width: 100%;
    }
    #groupedList.e-listview .e-list-group-item {
        height: 0;
    }
    #splitter1 .settings.e-list-wrapper.e-list-multi-line.e-list-avatar {
        padding: 15px;
    }
    #buttonSection {
        padding: 7px;
    }
</style>

After completing the configurations, the output appears as like this.

See Also

Different Layouts in Vue Splitter

21 Aug 202614 minutes to read

Using the Splitter component, create multiple and nested pane layouts for common application scenarios.

Code editor style layout

Step 1:

Create the element with two child to render the outer Splitter and render the first pane of the vertical Splitter as a horizontal splitter.


<template>
   <ejs-splitter id='outerSplitter' ref="splitterObj" :created='onCreate' orientation='Vertical' class='splitterContent' width='100%' height='400px'>
            <e-panes>
                <e-pane size="53%" min ="30%" ></e-pane>
                <e-pane :content='pane4Content'></e-pane>
            </e-panes>
    </ejs-splitter>
</template>

<style>
    .code-editor #code-text {
        margin-left: 5px;
    }
    .code-editor .code-preview {
        margin-top: 15px;
        font-size: 12px;
    }
    .code-editor #target {
        margin: 20px auto;
        max-width: 600px;
    }
    .code-editor.control-section{
        min-height: 370px;
        margin-bottom: 15px;
        margin-top: 10px;
    }

    .code-editor .h3 {
        font-size: 14px;
        margin: 4px;
    }

    .code-editor .content {
        padding: 12px;
    }
    .code-editor .splitter-image {
        margin: 0 auto;
        display: flex;
        height: 115px;
        margin-top: 10px;
    }
</style>

<script setup>

import { SplitterComponent } from '@syncfusion/ej2-vue-layouts';
import { Splitter } from '@syncfusion/ej2-layouts';



export default Vue.extend({
    data: function() {
        return {
            pane4Content: function () {
                return { template : pane4Content }
            },
            pane1Content: `<div><div class="content"><h3 class="h3">HTML</h3><div class="code-preview"><<span>!DOCTYPE html></span><div><<span>html></span></div>
            <div><<span>body></span></div><<span>div</span> id="custom-image"><div style="margin-left: 5px"><<span>img</span> src="src/albert.png"></div>
            <div><<span>div</span>></div><div><<span>/body></span></div><div><<span>/html></span></div></div></div></div>`,
            pane2Content: `<div><div class="content"><h3 class="h3">CSS</h3><div class="code-preview"><span>img {</span><div id="code-text">margin:<span>0 auto;</span></div>
            <div id="code-text">display:<span>flex;</span></div><div id="code-text">height:<span>70px;</span></div><span>}</span></div></div></div>`,
            pane3Content: `<div><div class="content"><h3 class="h3">JavaScript</h3><div class="code-preview"><span>var </span>
            image = document.getElementById("custom-image");<div>image.addEventListener("click", function() {</div>
            <div style="padding-left: 20px;">// Code block for click action</div><span> }</span></div></div></div>`,
            pane4Content: `
            <div>
                <div class="content">
                    <h3 class="h3">Preview of sample</h3>
                    <div class="splitter-image">
                        <img class="img1" src="https://ej2.syncfusion.com/demos/src/listview/images/albert.png" style="width: 20%;margin: 0 auto;">
                    </div>
                </div>
            </div>
`
        }
    },
    methods: {
        onCreate: function () {
            document.getElementById('outerSplitter').querySelector('.e-pane-vertical').setAttribute('id', 'Innersplitter');
            this.splitterObj1 = new Splitter({
                height: '220px',
                paneSettings: [
                    { size: '29%', min: '23%', content: this.pane1Content },
                    { size: '20%', min: '15%', content: this.pane2Content },
                    { size: '35%', min: '35%', content: this.pane3Content }
                ],
                width: '100%'
            });
            this.splitterObj1.appendTo('#Innersplitter');
        }
    }
});
</script>

After completing the above configuration, the output appears as shown in the demo

Outlook style layout

Step 1:

Create the element with three panes and place the elements within the pane to render treeview, listview and RTE.

<template>
    <ejs-splitter id='splitter' ref="splitterObj" width='100%' height='498px'>
            <e-panes>
                <e-pane size="28%" min="27%" :content='pane1Content'></e-pane>
                <e-pane size="33%" min ="23%" :content='pane2Content'></e-pane>
                <e-pane size="37%" min ="30%" :content='pane3Content'></e-pane>
            </e-panes>
    </ejs-splitter>
</template>

<style>
    .outlook-style #target {
        margin: 20px auto;
        max-width: 820px;
    }
    .outlook-style #discard {
        margin-left: 7px;
    }
    .outlook-style table {
        width: 100%;
        border: none;
    }
    .outlook-style td {
        padding: 2px;
    }
    .outlook-style.control-section {
        min-height: 370px;  
    }
    .outlook-style .e-treeview .e-list-text {
        width: 100%;
    }
    .outlook-style #groupedList.e-listview .e-list-group-item {
        height: 0;
    }
    .outlook-style #splitter1 .settings.e-list-wrapper.e-list-multi-line.e-list-avatar {
        padding: 15px;
    }
    .outlook-style #buttonSection {
        padding: 7px;
    }
    .outlook-style #createpostholder {
        padding-left: 3px;
        padding-right: 4px;
    }
</style>
<script setup>

import { SplitterComponent } from '@syncfusion/ej2-vue-layouts';
import pane1Content from "./outlook-pane1-content.vue";
import pane2Content from "./outlook-pane2-content.vue";
import pane3Content from "./outlook-pane3-content.vue";




export default Vue.extend({
    data: function() {
        return {
            pane1Content: function () {
                return { template : pane1Content }
            },
            pane2Content: function () {
                return { template : pane2Content }
            },
            pane3Content: function () {
                return { template : pane3Content }
            }
        }
    }
});
</script>

Step 2 :

Create separate template files to render the inner components.

The following template defines the TreeView component.


<template>
<div>
    <div class="tree-template-control-wrapper">
        <ejs-treeview id="template" :fields="fields" cssClass="custom" :nodeTemplate="treeTemplate"></ejs-treeview>
    </div>
</div>
</template>
<style>
    .tree-template-control-wrapper .e-treeview .e-list-text {
        width: 100%;
    }
</style>
<script setup>

import { TreeViewComponent } from "@syncfusion/ej2-vue-navigations";



var mailBox = [
        { id: 1, name: 'Favorites', hasChild: true},
        { id: 2, pid: 1, name: 'Sales Reports', count: '4' },
        { id: 3, pid: 1, name: 'Sent Items'},
        { id: 4, pid: 1, name: 'Marketing Reports ', count: '6'},
        { id: 5, name: 'Andrew Fuller', hasChild: true, expanded: true },
        { id: 6, pid: 5, name: 'Inbox',  selected: true , count: '20'},
        { id: 7, pid: 5,  name: 'Drafts', count: '5'},
        { id: 8, pid: 5,  name: 'Deleted Items'},
        { id: 9, pid: 5, name: 'Sent Items'},
        { id: 10, pid: 5, name: 'Sales Reports' , count: '4'},
        { id: 11, pid: 5, name: 'Marketing Reports', count: '6' },
        { id: 12, pid: 5, name: 'Outbox' },
        { id: 13, pid: 5, name: 'Junk Email'},
        { id: 14, pid: 5, name: 'RSS Feed'},
        { id: 15, pid: 5, name: 'Trash' }
];

var treeTemplate = Vue.component("demo", {
  template: '<div><div class="treeviewdiv"><div style="float:left"><span class="treeName"></span></div>' +
        '<div v-if="data.count" style="margin-right: 5px; float:right"><span class="treeCount e-badge e-badge-primary"></span></div></div></div>',
  data() {
    return {
      data: {}
    };
  }
});

export default Vue.extend ({
    data: function() {
        return {
            fields: { dataSource: mailBox, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' },
            treeTemplate: function(e) {
                return {
                    template: treeTemplate
                };
            },
        };
    }
});
</script>

The following template defines the ListView component.


<template>
<div>
    <ejs-listview id='listview' :dataSource='outlookdata' :cssClass='cssClass' :template='datatemplate'></ejs-listview>
</div>
</template>
<script setup>

import { ListViewComponent } from "@syncfusion/ej2-vue-lists";
import { enableRipple } from "@syncfusion/ej2-base";
import datatempVue from "./data-vue-template.vue";

enableRipple(false);

export default Vue.extend({
  data: function() {
    return {
      cssClass: "e-list-template",
      outlookdata: [
       { Name: 'Selma Tally', content1: 'Apology marketing email', content2:'Hello Ananya Singleton' },
       { Name: 'Illa Russo', content1: 'Annual conference', content2: 'Hi jeani Moresa' },
       { Name: 'Camden Macmellon', content1: 'Reference request- Camden hester', content2: 'Hello Kerry Best,' },
       { Name: 'Garth Owen', content1: 'Application for job Title', content2: 'Hello Illa Russo' },
       { Name: 'Ursula Patterson', content1: 'Programmaer Position Applicant', content2: 'Hello Kerry best,' }
      ],
      datatemplate: function() {
        return {
          template: datatempVue
        };
      }
    };
  }
});
</script>

The following template defines the Rich Text Editor component.


<template>
<div>
        <div style="width: 100%; padding: 15px;">
            <table>
                <tr>
                    <td><ejs-button cssClass='e-flat e-outline' isprimary=true >To...</ejs-button></td>
                    <td><ejs-textbox id="firstname" /></td>
                </tr>
                <tr>
                    <td><ejs-button cssClass='e-flat e-outline'>Cc...</ejs-button></td>
                    <td><ejs-textbox id="lastname" /></td>
                </tr>
                <tr>
                    <td><div id="subject-text">Subject</div></td>
                    <td><ejs-textbox id="subject" /></td>
                </tr>
            </table>
        </div>
        <div class="forum">
        <div id="createpostholder">
                <ejs-richtexteditor ref="rteInstance" height='262px'></ejs-richtexteditor>
                <div id="buttonSection">
                    <ejs-button :isPrimary="isPrimary" id="send" >Send</ejs-button>
                    <ejs-button id="discard" >Discard</ejs-button>
                </div>
        </div>
    </div>
</div>
</template>
<script setup>

import { RichTextEditorComponent, Link, Image, HtmlEditor, Toolbar } from "@syncfusion/ej2-vue-richtexteditor";
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';
import { TextBoxComponent } from '@syncfusion/ej2-vue-inputs';





export default Vue.extend({
    data: function() {
        return {
        isPrimary: true
        };
    },
    mounted: function() {
        this.$nextTick(function () {
            this.$refs.rteInstance.$el.ej2_instances[0].refresh();
        })
    },
    provide:{
        richtexteditor:[Link, Image, HtmlEditor, Toolbar]
    }
});
</script>

Once the above configurations have been completed, the output will appear as shown in the this.

See Also

Different Layouts in React Splitter

Using the React Splitter component, create complex layouts with multiple and nested panes.

Code editor style layout

Create an element with two child panes to render the outer Splitter. Then create an inner Splitter inside the first pane of the vertical Splitter.

[Class-component]

import { Splitter } from '@syncfusion/ej2-layouts';
import { PaneDirective, PanesDirective, SplitterComponent } from '@syncfusion/ej2-react-layouts';
import * as React from "react";

class App extends React.Component {
  public splitterInstance: Splitter;
    public paneSize1 = "53%";
    public minimumSize1 = "30%";
    public content1 = `<div class="splitter-content">
        <h3 class="h3">Preview of sample</h3>
        <div class="splitter-image">
            <img class="img1" src="https://ej2.syncfusion.com/demos/src/listview/images/albert.png" style="width: 20%;margin: 0 auto;">
        </div>
    </div>`;
    public onCreate(e: any): void {
      (this.splitterInstance as any).element.querySelector('.e-pane').setAttribute('id','splitter1');
      // Initialize Splitter component
     const splitterObj = new Splitter({
          height: '240px',
          paneSettings: [
              { content:`<div class="splitter-content">
              <h3 class="h3">HTML</h3>
              <div class="code-preview">
                  &lt;<span>!DOCTYPE html></span>
                  <div>&lt;<span>html></span></div>
                  <div>&lt;<span>body></span></div>
                  &lt;<span>div</span> id="custom-image">
                  <div style="margin-left: 5px">&lt;<span>img</span> src="src/albert.png"></div>
                  <div>&lt;<span>div</span>&gt;</div>
                  <div>&lt;<span>/body></span></div>
                  <div>&lt;<span>/html></span></div>
              </div>
              </div>`,
              min: '23%', size: '29%'  },
              { content: `<div class="splitter-content">
              <h3 class="h3">CSS</h3>
              <div class="code-preview">
                  <span>img {</span>
                      <div id="code-text">margin:<span>0 auto;</span></div>
                      <div id="code-text">display:<span>flex;</span></div>
                      <div id="code-text">height:<span>70px;</span></div>
                  <span>   }</span>
              </div>
              </div>`,min: '15%', size: '20%' },
              { content: `<div class="splitter-content">
              <h3 class="h3">JavaScript</h3>
              <div class="code-preview">
                  <span>var</span> image = document.getElementById("custom-image");
                  <div>image.addEventListener("click", function() {</div>
                      <div style="padding-left: 20px;">// Code block for click action</div>
                  <span> }</span>
              </div>
              </div>`,
              min: '35%', size: '35%' }
          ],
          width: '100%'
          });
          splitterObj.appendTo('#splitter1');
  }
    public render(): JSX.Element {
  return (
    <div id="target" className="control-section code-editor" >
      <SplitterComponent id="splitter2" height="400px" orientation="Vertical" ref={(splitter) => { this.splitterInstance = splitter! }} created={this.onCreate = this.onCreate.bind(this)}>
          <PanesDirective>
            <PaneDirective />
            <PaneDirective size={this.paneSize1} min={this.minimumSize1} content={this.content1}/>
          </PanesDirective>
      </SplitterComponent>
    </div>
  );
}
}
export default App;

[Functional-component]

import { Splitter } from '@syncfusion/ej2-layouts';
import { PaneDirective, PanesDirective, SplitterComponent } from '@syncfusion/ej2-react-layouts';
import * as React from "react";

function App () {
  let splitterInstance: Splitter;
    let paneSize1 = "53%";
    let minimumSize1 = "30%";
    let content1 = `<div class="splitter-content">
        <h3 class="h3">Preview of sample</h3>
        <div class="splitter-image">
            <img class="img1" src="https://ej2.syncfusion.com/demos/src/listview/images/albert.png" style="width: 20%;margin: 0 auto;">
        </div>
    </div>`;
    function onCreate(e: any): void {
      (splitterInstance as any).element.querySelector('.e-pane').setAttribute('id','splitter1');
      // Initialize Splitter component
     const splitterObj = new Splitter({
          height: '240px',
          paneSettings: [
              { content:`<div class="splitter-content">
              <h3 class="h3">HTML</h3>
              <div class="code-preview">
                  &lt;<span>!DOCTYPE html></span>
                  <div>&lt;<span>html></span></div>
                  <div>&lt;<span>body></span></div>
                  &lt;<span>div</span> id="custom-image">
                  <div style="margin-left: 5px">&lt;<span>img</span> src="src/albert.png"></div>
                  <div>&lt;<span>div</span>&gt;</div>
                  <div>&lt;<span>/body></span></div>
                  <div>&lt;<span>/html></span></div>
              </div>
              </div>`,
              min: '23%', size: '29%'  },
              { content: `<div class="splitter-content">
              <h3 class="h3">CSS</h3>
              <div class="code-preview">
                  <span>img {</span>
                      <div id="code-text">margin:<span>0 auto;</span></div>
                      <div id="code-text">display:<span>flex;</span></div>
                      <div id="code-text">height:<span>70px;</span></div>
                  <span>   }</span>
              </div>
              </div>`,min: '15%', size: '20%' },
              { content: `<div class="splitter-content">
              <h3 class="h3">JavaScript</h3>
              <div class="code-preview">
                  <span>var</span> image = document.getElementById("custom-image");
                  <div>image.addEventListener("click", function() {</div>
                      <div style="padding-left: 20px;">// Code block for click action</div>
                  <span> }</span>
              </div>
              </div>`,
              min: '35%', size: '35%' }
          ],
          width: '100%'
          });
          splitterObj.appendTo('#splitter1');
  }

  return (
    <div id="target" className="control-section code-editor" >
      <SplitterComponent id="splitter2" height="400px" orientation="Vertical" ref={(splitter) => { splitterInstance = splitter! }} created={onCreate = onCreate.bind(this)}>
          <PanesDirective>
            <PaneDirective />
            <PaneDirective size={paneSize1} min={minimumSize1} content={content1}/>
          </PanesDirective>
      </SplitterComponent>
    </div>
  );

}
export default App;

Once the above configurations have been completed, you will see output like this.

Outlook style layout

Create an element with three panes and place the required components inside each pane to render TreeView, ListView, and Rich Text Editor.

[Class-component]

import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { PaneDirective, PanesDirective, SplitterComponent } from '@syncfusion/ej2-react-layouts';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, } from '@syncfusion/ej2-react-richtexteditor';
import * as React from "react";

class App extends React.Component <{}, {}, any> {
  public splitterInstance: SplitterComponent;
  public listViewObj: ListViewComponent;
  public rteObj: RichTextEditorComponent;
  public treeInstance: TreeViewComponent;
  public textBox1: TextBoxComponent;
  public textBox2: TextBoxComponent;
  public textBox3: TextBoxComponent;

  public dataSource: any = [
    { Name: 'Selma Tally', content: 'Apology marketing email',content2:'Hello Ananya Singleton', id: '1', order: 0 },
    { Name: 'Illa Russo', content: 'Annual conference', content2: 'Hi jeani Moresa', id: '4', order: 0 },
    { Name: 'Camden Macmellon', content: 'Reference request- Camden hester', content2: 'Hello Kerry Best', order: 0 },
    { Name: 'Garth Owen', content: 'Application for job Title', content2:'Hello Illa Russo', id: '2', order: 0 },
    { Name: 'Ursula Patterson', content: 'Programmaer Position Applicant', content2: 'Hello Kerry best', id: '2', order: 0 }
  ];

  public paneSize1 = "28%";
  public minimumSize1 = "27%";
  public content1 = "<div class='splitter-content'></div>";
  public paneSize2 = "33%";
  public minimumSize2 = "23%";
  public content2 = "<div class='splitter-content'></div>";
  public paneSize3 = "37%";
  public minimumSize3 = "30%";
  public content3 = "<div ><div class='splitter-content'><div style = 'width: 100%; padding: 15px;'><table><tr><td><button class='e-btn e-flat e-outline'>To...</button></td>" +
  "<td id='firstname-target'></td></tr><tr><td><button class='e-btn e-flat e-outline'>Cc...</button></td><td id ='lastname-target'></td>" +
  "</tr><tr><td><div id='subject-text'>Subject</div></td><td id='subject-target'></td></tr></table></div>" +
  "<div class='forum'><div id='createpostholder'><div id='buttonSection'><button class='e-btn e-primary' id='send'>Send</button>" +
  "<button class='e-btn' id='discard'>Discard</button></div></div></div></div></div>";
  // Set customized list template
  public listTemplate: string = '<div class="settings e-list-wrapper e-list-multi-line e-list-avatar">' +
    '<span class="e-list-item-header">${Name}</span>' +
    '<span class="e-list-content">${content}</span>' +
    '</div>'
  // Set customized group-header template
  public grouptemplate: string = '<div class="e-list-wrapper"><span class="e-list-item-content"></span></div>';
  // Map the appropriate columns to fields property
  public listFields: object = { text: 'Name', groupBy: 'order' };
  public mailBox: object[] = [
    { id: 1, name: 'Favorites', hasChild: true},
    { id: 2, pid: 1, name: 'Sales Reports', count: '4' },
    { id: 3, pid: 1, name: 'Sent Items'},
    { id: 4, pid: 1, name: 'Marketing Reports ', count: '6'},
    { id: 5, name: 'Andrew Fuller', hasChild: true, expanded: true },
    { id: 6, pid: 5, name: 'Inbox',  selected: true , count: '20'},
    { id: 7, pid: 5,  name: 'Drafts', count: '5'},
    { id: 15, pid: 5, name: 'Archive'},
    { id: 8, pid: 5,  name: 'Deleted Items'},
    { id: 9, pid: 5, name: 'Sent Items'},
    { id: 10, pid: 5, name: 'Sales Reports' , count: '4'},
    { id: 11, pid: 5, name: 'Marketing Reports', count: '6' },
    { id: 12, pid: 5, name: 'Outbox'},
    { id: 13, pid: 5, name: 'Junk Email'},
    { id: 14, pid: 5, name: 'RSS Feed'},
    { id: 15, pid: 5, name: 'Trash' }
  ];
  private  treeFields: object = { dataSource: this.mailBox, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' };

  public onCreate(e: any): void {
    this.splitterInstance.element.querySelectorAll('.splitter-content')[0].appendChild(this.treeInstance.element);
    this.splitterInstance.element.querySelectorAll('.splitter-content')[1].appendChild(this.listViewObj.element);
    (this.splitterInstance as any).element.querySelector('#createpostholder').insertBefore(this.rteObj.element, (this.splitterInstance as any).element.querySelector('#createpostholder').childNodes[0]);
    (this.splitterInstance as any).element.querySelector('#firstname-target').appendChild(this.textBox1.element.parentElement);
    (this.splitterInstance as any).element.querySelector('#lastname-target').appendChild(this.textBox2.element.parentElement);
    (this.splitterInstance as any).element.querySelector('#subject-target').appendChild(this.textBox3.element.parentElement);
  }
  public nodeTemplate(dataSource: any): JSX.Element {
    return(<div>
        <div className="treeviewdiv">
          <div className="textcontent">
            <span className="treeName">{dataSource.name}</span>
          </div>
            { dataSource.count &&
            <div className="countcontainer">
              <span className="treeCount e-badge e-badge-primary" >{dataSource.count}</span>
            </div>
          }
        </div>
      </div>);
  };
  public onSplitterResize(): void {
    this.rteObj.refresh();
  }

  public render(): JSX.Element {
  return (
      <div id="target" className="control-section outlook-style" >
      <TextBoxComponent id="firstname" ref={(textbox) => { this.textBox1 = textbox! }}/>
      <TextBoxComponent id="lastname" ref={(textbox) => { this.textBox2 = textbox! }}/>
      <TextBoxComponent id="subject" ref={(textbox) => { this.textBox3 = textbox! }}/>
      <RichTextEditorComponent id="defaultRTE" ref={(richtexteditor) => { this.rteObj = richtexteditor! }}  height = "262px">
          <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]} />
      </RichTextEditorComponent>
      <TreeViewComponent id='splitter-tree' fields= {this.treeFields} nodeTemplate = {this.nodeTemplate} ref={(tree) => { this.treeInstance = tree! }}/>
      <ListViewComponent id='groupedList-split' fields = { this.listFields } className ='splitter-list' dataSource = {this.dataSource}
      cssClass = {'e-list-template'} groupTemplate = {this.grouptemplate} template = {this.listTemplate} ref={(listview) => { this.listViewObj = listview! }}/>
      <SplitterComponent id="splitter1" height="493px" width="100%" ref={(splitter) => { this.splitterInstance = splitter! }} created={this.onCreate = this.onCreate.bind(this)} resizeStop={this.onSplitterResize=this.onSplitterResize.bind(this)}>
          <PanesDirective>
              <PaneDirective size={this.paneSize1} min={this.minimumSize1} content={this.content1}/>
              <PaneDirective size={this.paneSize2} min={this.minimumSize2} content={this.content2}/>
              <PaneDirective size={this.paneSize3} min={this.minimumSize3} content={this.content3}/>
          </PanesDirective>
      </SplitterComponent>
      </div>
  );
}
}
export default App;

[Functional-component]

import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { PaneDirective, PanesDirective, SplitterComponent } from '@syncfusion/ej2-react-layouts';
import { ListViewComponent } from '@syncfusion/ej2-react-lists';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Toolbar, } from '@syncfusion/ej2-react-richtexteditor';
import * as React from "react";

function App () {
  let splitterInstance: SplitterComponent;
  let listViewObj: ListViewComponent;
  let rteObj: RichTextEditorComponent;
  let treeInstance: TreeViewComponent;
  let textBox1: TextBoxComponent;
  let textBox2: TextBoxComponent;
  let textBox3: TextBoxComponent;

  let dataSource: any = [
    { Name: 'Selma Tally', content: 'Apology marketing email',content2:'Hello Ananya Singleton', id: '1', order: 0 },
    { Name: 'Illa Russo', content: 'Annual conference', content2: 'Hi jeani Moresa', id: '4', order: 0 },
    { Name: 'Camden Macmellon', content: 'Reference request- Camden hester', content2: 'Hello Kerry Best', order: 0 },
    { Name: 'Garth Owen', content: 'Application for job Title', content2:'Hello Illa Russo', id: '2', order: 0 },
    { Name: 'Ursula Patterson', content: 'Programmaer Position Applicant', content2: 'Hello Kerry best', id: '2', order: 0 }
  ];

  let paneSize1 = "28%";
  let minimumSize1 = "27%";
  let content1 = "<div class='splitter-content'></div>";
  let paneSize2 = "33%";
  let minimumSize2 = "23%";
  let content2 = "<div class='splitter-content'></div>";
  let paneSize3 = "37%";
  let minimumSize3 = "30%";
  let content3 = "<div ><div class='splitter-content'><div style = 'width: 100%; padding: 15px;'><table><tr><td><button class='e-btn e-flat e-outline'>To...</button></td>" +
  "<td id='firstname-target'></td></tr><tr><td><button class='e-btn e-flat e-outline'>Cc...</button></td><td id ='lastname-target'></td>" +
  "</tr><tr><td><div id='subject-text'>Subject</div></td><td id='subject-target'></td></tr></table></div>" +
  "<div class='forum'><div id='createpostholder'><div id='buttonSection'><button class='e-btn e-primary' id='send'>Send</button>" +
  "<button class='e-btn' id='discard'>Discard</button></div></div></div></div></div>";
  // Set customized list template
  let listTemplate: string = '<div class="settings e-list-wrapper e-list-multi-line e-list-avatar">' +
    '<span class="e-list-item-header">${Name}</span>' +
    '<span class="e-list-content">${content}</span>' +
    '</div>'
  // Set customized group-header template
  let grouptemplate: string = '<div class="e-list-wrapper"><span class="e-list-item-content"></span></div>';
  // Map the appropriate columns to fields property
  let listFields: object = { text: 'Name', groupBy: 'order' };
  let mailBox: object[] = [
    { id: 1, name: 'Favorites', hasChild: true},
    { id: 2, pid: 1, name: 'Sales Reports', count: '4' },
    { id: 3, pid: 1, name: 'Sent Items'},
    { id: 4, pid: 1, name: 'Marketing Reports ', count: '6'},
    { id: 5, name: 'Andrew Fuller', hasChild: true, expanded: true },
    { id: 6, pid: 5, name: 'Inbox',  selected: true , count: '20'},
    { id: 7, pid: 5,  name: 'Drafts', count: '5'},
    { id: 15, pid: 5, name: 'Archive'},
    { id: 8, pid: 5,  name: 'Deleted Items'},
    { id: 9, pid: 5, name: 'Sent Items'},
    { id: 10, pid: 5, name: 'Sales Reports' , count: '4'},
    { id: 11, pid: 5, name: 'Marketing Reports', count: '6' },
    { id: 12, pid: 5, name: 'Outbox'},
    { id: 13, pid: 5, name: 'Junk Email'},
    { id: 14, pid: 5, name: 'RSS Feed'},
    { id: 15, pid: 5, name: 'Trash' }
  ];
  let  treeFields: object = { dataSource: mailBox, id: 'id', parentID: 'pid', text: 'name', hasChildren: 'hasChild' };

  function onCreate(e: any): void {
    splitterInstance.element.querySelectorAll('.splitter-content')[0].appendChild(treeInstance.element);
    splitterInstance.element.querySelectorAll('.splitter-content')[1].appendChild(listViewObj.element);
    (splitterInstance as any).element.querySelector('#createpostholder').insertBefore(rteObj.element, (splitterInstance as any).element.querySelector('#createpostholder').childNodes[0]);
    (splitterInstance as any).element.querySelector('#firstname-target').appendChild(textBox1.element.parentElement);
    (splitterInstance as any).element.querySelector('#lastname-target').appendChild(textBox2.element.parentElement);
    (splitterInstance as any).element.querySelector('#subject-target').appendChild(textBox3.element.parentElement);
  }
  function nodeTemplate(dataSource: any): JSX.Element {
    return(<div>
        <div className="treeviewdiv">
          <div className="textcontent">
            <span className="treeName">{dataSource.name}</span>
          </div>
            { dataSource.count &&
            <div className="countcontainer">
              <span className="treeCount e-badge e-badge-primary" >{dataSource.count}</span>
            </div>
          }
        </div>
      </div>);
  };
  function onSplitterResize(): void {
    rteObj.refresh();
  }


  return (
      <div id="target" className="control-section outlook-style" >
      <TextBoxComponent id="firstname" ref={(textbox) => { textBox1 = textbox! }}/>
      <TextBoxComponent id="lastname" ref={(textbox) => { textBox2 = textbox! }}/>
      <TextBoxComponent id="subject" ref={(textbox) => { textBox3 = textbox! }}/>
      <RichTextEditorComponent id="defaultRTE" ref={(richtexteditor) => { rteObj = richtexteditor! }}  height = "262px">
          <Inject services={[HtmlEditor, Toolbar, Image, Link, QuickToolbar]} />
      </RichTextEditorComponent>
      <TreeViewComponent id='splitter-tree' fields= {treeFields} nodeTemplate = {nodeTemplate} ref={(tree) => { treeInstance = tree! }}/>
      <ListViewComponent id='groupedList-split' fields = { listFields } className ='splitter-list' dataSource = {dataSource}
      cssClass = {'e-list-template'} groupTemplate = {grouptemplate} template = {listTemplate} ref={(listview) => { listViewObj = listview! }}/>
      <SplitterComponent id="splitter1" height="493px" width="100%" ref={(splitter) => { splitterInstance = splitter! }} created={onCreate = onCreate.bind(this)} resizeStop={onSplitterResize=onSplitterResize.bind(this)}>
          <PanesDirective>
              <PaneDirective size={paneSize1} min={minimumSize1} content={content1}/>
              <PaneDirective size={paneSize2} min={minimumSize2} content={content2}/>
              <PaneDirective size={paneSize3} min={minimumSize3} content={content3}/>
          </PanesDirective>
      </SplitterComponent>
      </div>
  );

}
export default App;

Include the following dependent styles at the top of your App.css file.

@import '../../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../../node_modules/@syncfusion/ej2-layouts/styles/material.css';
@import '../../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import '../../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../../node_modules/@syncfusion/ej2-richtexteditor/styles/material.css';
@import '../../node_modules/@syncfusion/ej2-buttons/styles/material.css';

Once the above configurations have been completed, you will see output like this.

See Also